#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 3);
	int n = atoi(argv[1]);
	int maxc = atoi(argv[2]);

	vector<pii> poly1;
	vector<pii> poly2;
	for (int i = 0; i < n; ++i) {
		int x = rnd.next(-maxc, maxc);
		int y = rnd.next(-maxc, maxc);
		poly1.push_back({x, y});
		poly2.push_back({x, y});
	}

	rotate(poly2.begin(), poly2.begin() + rnd.next(0, n - 1), poly2.end());

	int rots = rnd.next(0, 3);
	for (int i = 0; i < rots; ++i) {
		for (pii& p : poly2) {
			p = {p.ss, -p.ff};
		}
	}

	if (rnd.next(0, 1)) {
		for (pii& p : poly2) {
			swap(p.ff, p.ss);
		}
	}

	int minx = INF, maxx = -INF, miny = INF, maxy = -INF;

	for (pii p : poly2) {
		minx = min(minx, p.ff);
		maxx = max(maxx, p.ff);
		miny = min(miny, p.ss);
		maxy = max(maxy, p.ss);
	}

	int addx = rnd.next(-maxc - minx, maxc - maxx);
	int addy = rnd.next(-maxc - miny, maxc - maxy);

	for (pii& p : poly2) {
		p.ff += addx;
		p.ss += addy;
	}

	if (rnd.next(0, 1)) {
		reverse(poly2.begin(), poly2.end());
	}

	cout << n << "\n";

	for (pii p : poly1) {
		cout << p.ff << " " << p.ss << "\n";
	}

	cout << n << "\n";

	for (pii p : poly2) {
		cout << p.ff << " " << p.ss << "\n";
	}

	return 0;
}