#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

long long chars[30];

int solve() {
	string s;
	cin >> s;

	long long n = (int)s.size();
	for (int i = 0; i < n; i++) {
		chars[s[i] - 'a']++; 
	}

	long long cnt = 0;
	for (char c = 'a'; c <= 'z'; c++) {
		cnt += chars[c - 'a'] * (chars[c - 'a'] - 1) / 2;
	}

	cout << n * (n - 1) / 2 - cnt + 1;
	return 0;
}