#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include "testlib.h"
#include <set>

using namespace std;

const int MAXN = (int)1e3;
const int MAXD = (int)1e9;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int maxD = atoi(argv[3]);

    vector<vector<int>> test(n, vector<int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            test[i][j] = rnd.next(1, maxD);
        }
    }

    cout << n << ' ' << m << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << test[i][j];
            if (j != m - 1) cout << ' ';
        }
        cout << endl;
    }
    return 0;
 }