#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 2);
	int maxc = atoi(argv[1]);

	map<int, pii> have;
	for (int i = 0; i <= maxc; ++i) {
		for (int j = 0; j <= maxc; ++j) {
			have[i * i + j * j] = {i, j};
		}
	}

	vector<int> lens;
	for (auto p : have) {
		lens.push_back(p.ff);
	}

	double best = INF;
	int mem = -1;
	for (int i = 0; i < szof(lens) - 1; ++i) {
		double tmp = sqrt(lens[i + 1]) - sqrt(lens[i]);
		if (tmp < best) {
			best = tmp;
			mem = i;
		}
	}

	pii v1 = have[lens[mem]];
	pii v2 = have[lens[mem + 1]];

	pii cur1 = {-maxc, 0}, cur2 = {-maxc, 0};
	vector<pii> poly1, poly2;
	poly1.push_back(cur1);
	poly2.push_back(cur2);
	pii v11 = v1;
	pii v12 = v1;
	pii v21 = v2;
	pii v22 = v2;
	cur1.ff += v11.ff; cur1.ss += v11.ss;
	poly1.push_back(cur1);
	cur1.ff += v12.ff; cur1.ss -= v12.ss;
	poly1.push_back(cur1);
	cur1.ff -= v11.ff; cur1.ss -= v11.ss;
	poly1.push_back(cur1);
	
	cur2.ff += v21.ff; cur2.ss += v21.ss;
	poly2.push_back(cur2);
	cur2.ff += v22.ff; cur2.ss -= v22.ss;
	poly2.push_back(cur2);
	cur2.ff -= v21.ff; cur2.ss -= v21.ss;
	poly2.push_back(cur2);

	cout << 4 << "\n";
	for (pii p : poly1) {
		cout << p.ff << " " << p.ss << "\n";
	}
	cout << 4 << "\n";
	for (pii p : poly2) {
		cout << p.ff << " " << p.ss << "\n";
	}

	return 0;
}