#include <iostream>
#include <iomanip>
#include <cmath>

using namespace std;

typedef long long ll;

ll sqr(int num) {
	return (ll) num * num;
}

int main(){
	cout << fixed << setprecision(15);
	int n, m;
	cin >> n;
	int lx, ly; //last point (x and y)
	int cx, cy; //current point (x and y)
	double p1 = 0, p2 = 0; //perimeter of polygons
	int fx, fy; // first point (x and y)
	cin >> fx >> fy;
	lx = fx, ly = fy;
	for (int i = 1; i < n; i++){
		cin >> cx >> cy;
		p1 += sqrt(sqr(lx - cx) + sqr(ly - cy));
		lx = cx, ly = cy;
	}
	p1 += sqrt(sqr(fx - lx) + sqr(fy - ly));
	cin >> m;
	cin >> fx >> fy;
	lx = fx, ly = fy;
	for (int i = 1; i < m; i++){
		cin >> cx >> cy;
		p2 += sqrt(sqr(lx - cx) + sqr(ly - cy));
		lx = cx, ly = cy;
	}
	p2 += sqrt(sqr(fx - lx) + sqr(fy - ly));
	if (fabs(p1 - p2) < 1e-8) {
		cout << "Yes\n";
	} else {
		cout << "No\n";
	}
	return 0;
}
