#include <bits/stdc++.h>
#include "testlib.h"
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	
	set<pair<int, int> > S;
	vector<pair<int, int> > edges(m);
	for (int i = 0; i < n - 1; i++) {
		int to = rnd.next(1, i + 1);
		if (rnd.next(2)) edges[i] = { i + 2, to };
		else edges[i] = { to, i + 2 };
		
		S.insert({ edges[i].first, edges[i].second });
		S.insert({ edges[i].second, edges[i].first });
	}
	
	for (int i = n - 1; i < m; i++) {
		int a = rnd.next(1, n);
		int b = rnd.next(1, n);
		while (a == b || S.count({ a, b })) a = rnd.next(1, n), b = rnd.next(1, n);
		edges[i] = { a, b };
		S.insert({ a, b });
		S.insert({ b, a });
	}
	shuffle(edges.begin(), edges.end());
	cout << n << " " << m << "\n";
	for (auto c : edges) cout << c.first << " " << c.second << "\n";
	return 0;
}